---
### Generate cert https ###
- name: cert HTTPS exists
  ansible.builtin.stat:
    path: "/etc/elasticsearch/certs/https.p12"
  register: https_file

- name: generate HTTPS answer file
  ansible.builtin.template:
    src: https_answer_file.txt.j2
    dest: /tmp/https_answer_file.txt
    mode: 0400
  when: not https_file.stat.exists

- name: generate HTTPS cert script
  ansible.builtin.template:
    src: generate_https_certs.sh.j2
    dest: "/usr/local/sbin/generate_https_certs.sh"
    mode: 0700

- name: generate HTTPS cert
  ansible.builtin.command: "/usr/local/sbin/generate_https_certs.sh"
  when: not https_file.stat.exists

- name: Unarchive HTTPS zip file
  ansible.builtin.unarchive:
    src: "/tmp/elasticsearch-ssl-http.zip"
    dest: /tmp/
    remote_src: yes
  when: not https_file.stat.exists

- name: Copy http.p12 file in cert dir
  ansible.builtin.copy:
    src: /tmp/elasticsearch/http.p12
    dest: "/etc/elasticsearch/certs/https.p12"
    owner: "root"
    group: "elasticsearch"
    remote_src: yes
  when: not https_file.stat.exists

- name: Copy elasticsearch-ca.pem in cert dir
  ansible.builtin.copy:
    src: /tmp/kibana/elasticsearch-ca.pem
    dest: "/etc/elasticsearch/certs/elasticsearch-ca.pem"
    owner: "root"
    group: "elasticsearch"
    remote_src: yes

- ansible.builtin.fetch:
    src: /tmp/kibana/elasticsearch-ca.pem
    dest: "{{ secu_path_elastic_certs }}/elasticsearch-ca.pem"
    flat: true
  run_once: true
  when: not https_file.stat.exists

- name: Remove HTTPS zip file
  ansible.builtin.file:
    path: "/tmp/elasticsearch-ssl-http.zip"
    state: absent

- name: Remove HTTPS temp dir
  ansible.builtin.file:
    path: /tmp/elasticsearch
    state: absent

- name: Remove HTTPS temp dir
  ansible.builtin.file:
    path: /tmp/kibana
    state: absent

- name: Remove answer file
  ansible.builtin.file:
    path: /tmp/https_answer_file.txt
    state: absent
